import shutil, sys
from utils import *

# inputs
#sender_paths = [["01100","00000"]] # x,y
#recv_paths = [["00010","01110","11110","10011","10011","00000",
#            "01101","01001","11011","11011","10101","01100"]]
sender_paths, recv_paths = generate_random_send_recv_paths(100, True)
repetitions = 10
test_name = "random_test"

# constants
stimuli = "# is external? | path | data\n"
reference = ""

data_packet = 1
for i in range(repetitions):
    dir_ref_count = dict(zip(directions, INI_REF_PATH_COUNT))
    for p, path in enumerate(sender_paths):
        if len(path) == 1:
            index_path, dir_ref_count = get_ext_index_path(path, dir_ref_count)
            stimuli += "1 " + str(index_path) + " " 
            if len(recv_paths[p]) == 1:
                data_packet, stimuli, reference = gen_ref_for_ext_msg(
                        path, recv_paths[p], data_packet, stimuli, reference)
            elif len(recv_paths[p]) == 2:
                data_packet, stimuli, reference = gen_ref_for_sing_dir(
                        path, recv_paths[p], data_packet, stimuli, reference)
            else:
                data_packet, stimuli, reference = gen_ref_for_mult_dir_multicast(
                        path, recv_paths[p], data_packet, stimuli, reference)
        elif len(path) == 2:
            index_path = get_index_path(path[0], path[1])
            stimuli += "0 " + str(index_path) + " " 
            if len(recv_paths[p]) == 1:
                data_packet, stimuli, reference = gen_ref_for_ext_msg(
                        path, recv_paths[p], data_packet, stimuli, reference)
            elif len(recv_paths[p]) == 2:
                data_packet, stimuli, reference = gen_ref_for_sing_dir(
                        path, recv_paths[p], data_packet, stimuli, reference)
            else:
                data_packet, stimuli, reference = gen_ref_for_mult_dir_multicast(
                        path, recv_paths[p], data_packet, stimuli, reference)
        data_packet += 1
    stimuli += "\n"

with open("stimuli.txt", "w") as f:
    f.write(stimuli)

with open("result.ref", "w") as f:
    f.write(reference)

shutil.copyfile("stimuli.txt", "../../input/noc_tests/"+test_name+"/stimuli.txt")
shutil.copyfile("stimuli.txt", "/home/juanmanuel/modelsim/stimuli.txt")
shutil.copyfile("result.ref", "../../input/noc_tests/"+test_name+"/result.ref")
